#ifndef __GRAFO_HPP__
#define __GRAFO_HPP__

#include "Point.hpp"

//0 = correndo, 1 = engatinhando
int dy[2][12]={{-2,-1,-1,-1,0,0,0,0,1,1,1,2},{-1,0,1,0}};
int dx[2][12]={{0,-1,0,1,-2,-1,1,2,-1,0,1,0},{0,1,0,-1}};
int td[2]={12,4};

struct Grafo {
	bool visitados[31][31];
	point pai[31][31];
	point fila[31*31];
	bool marked[31][31];
	int distance[31][31];
	int T;
	Grafo() : T(31) {}

	void bfs(int tipo,const point& inicial) {
		memset(visitados,0,sizeof(visitados));
		memset(distance,0x3f3f3f3f,sizeof(distance));
		visitados[inicial.y][inicial.x]=true;
		pai[inicial.y][inicial.x]=point(-1,-1);
		fila[0]=inicial;
		for(int comeco=0,final=1;comeco<final;comeco++) {
			point& p=fila[comeco];
			for(int k=0;k<td[tipo];k++) {
				int y=p.y+dy[tipo][k];
				int x=p.x+dx[tipo][k];
				int dois= std::abs(dy[tipo][k])==2 or std::abs(dx[tipo][k])==2;
				if(y>=0 and y<T and x>=0 and x<T and visitados[y][x]==false and marked[y][x]==false) {
					if(! (dois and (marked[(y+p.y)/2][(x+p.x)/2]==true))) {
						visitados[y][x]=true;
						fila[final++]=point(x,y);
						pai[y][x]=p;
						distance[y][x]=distance[p.y][p.x]+1;
					}
				}
			}
		}
	}
};

#endif
