#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <cmath>
using namespace std;
#include "Point.hpp"
#include "Grafo.hpp"
#include "Acao.hpp"

Estrategia possiveis_estrategias[1024];
int usando_estrategias[1024];
int n_possiveis_estrategias;

#include "Player.hpp"

#define T 31

#define MAXDIST 24*24

struct pos_grid {
	int height;
	char occupied;
};

pos_grid grid[31][31];

Player players[8];

bool can_pickup[31][31];

Grafo G;
#include "primitive_actions.hpp"

#include "entrada_saida.hpp"
#include "init.hpp"

point onde_ataque_vai_parar(const point& inicial, const point& final, int altura);

point ponto_mais_perto_de;
bool mais_perto_de(const pair<point,point> & p1, const pair<point,point>& p2) {
	return dist_manhatan(ponto_mais_perto_de,p1.first)<dist_manhatan(ponto_mais_perto_de,p2.first);
}
bool mais_perto_de2(const int& p1, const int& p2) {
	return dist_manhatan(ponto_mais_perto_de,players[p1].pos)<dist_manhatan(ponto_mais_perto_de,players[p2].pos);
}
bool mais_perto_de3(const point& p1, const point& p2) {
	return dist_manhatan(ponto_mais_perto_de,p1)<dist_manhatan(ponto_mais_perto_de,p2);
}
vector<point> all_with_max_dist(const point& p,int dist) {
	vector<point> ans;
	for(int i=0;i<T;i++)
		for(int j=0;j<T;j++) {
			if(max(std::abs(p.x-j),std::abs(p.y-i)) == dist)
				ans.push_back(point(j,i));
		}
	return ans;
}

bool espaco_livre(const pos_grid& pg) {
	return pg.height<6 and pg.occupied=='a';
}

void move(Player& p, const point& pos) {
	bool fez_acao=false;
	if(p.em_pe==false) {
		//TODO verificar se vale a pena ficar agaixado
		if( dist_manhatan(p.pos,pos) > 3) {
			_stand(p);
			fez_acao=true;
		}
	}
	if(!fez_acao) {
		G.marked[p.pos.y][p.pos.x]=false;
		G.bfs(  p.em_pe?0:1  ,pos);
		G.marked[p.pos.y][p.pos.x]=true;

		point& destino=G.pai[p.pos.y][p.pos.x];

		G.marked[destino.y][destino.x]=true;
		G.marked[(p.pos.y+destino.y)/2][(p.pos.x+destino.x)/2]=true;

		if(p.em_pe==true)
			_run(p,G.pai[p.pos.y][p.pos.x]);
		else
			_crawl(p,G.pai[p.pos.y][p.pos.x]);
	}
}

bool por_graph_distance(const point& p1, const point& p2) {
	return G.distance[p1.y][p1.x] < G.distance[p2.y][p2.x];
}

void move_pra_perto(Player& p, const point& pos) {
	vector<point> adjacentes;
	for(int i=0;i<T;i++)
		for(int j=0;j<T;j++) {
			point aux(j,i);
			if(adjacente(aux,pos) and espaco_livre(grid[i][j])) {
				adjacentes.push_back(aux);
			}
		}
	G.bfs(1,p.pos);
	point perto = *min_element(adjacentes.begin(),adjacentes.end(),por_graph_distance);
	move(p,perto);
}

//true = succefully throwed
//false = merda
bool throw_snow(Player& p, const point& pos) {
	if(p.holding<'e' or p.holding>'g')
		return false;
//	point delta(pos.x-p.pos.x,pos.y-p.pos.y);
//	if((delta*2).modulo() > MAXDIST)
//		return false;
	_throw(p,pos);
	return true;
}

void drop(Player& p, point pos) {
	//se esta adjacente, blz
	if(adjacente(p.pos,pos)) {
		_drop(p,pos);
	}
	//senao, vai pra la
	else {
		//XXX
		pos.x--;
		move(p,pos);
	}
}

void drop_adjacente(Player& p) {
	vector<point> possiveis= all_with_max_dist(p.pos,1);
	drop(p,possiveis[rand()%possiveis.size()]);
}

vector<point> neves_mais_pertas(point pos) {
	vector<point> pertos;
	for(int i=0;i<T;i++)
		for(int j=0;j<T;j++) {
			point aux(j,i);
			if(grid[i][j].height>0 and grid[i][j].occupied=='a') {
				if(pertos.size()==0)
					pertos.push_back(aux);
				else {
					if( dist_center(pertos[0],pos) > dist_center(aux,pos)) {
						pertos.clear();
						pertos.push_back(aux);
					}
					else if( dist_center(pertos[0],pos) == dist_center(aux,pos)) {
						pertos.push_back(aux);
					}
				}
			}
		}
	return pertos;
}
//XXX BUG, se nao tiver neves + pertas, SEGFAULT!
point neve_mais_perto(Player& p, point pos) {
	vector<point> pertos=neves_mais_pertas(pos);

	//retira os pontos que nao da para pegar
	for(int i=0;i<(int)pertos.size();i++) {
		if(can_pickup[pertos[i].y][pertos[i].x] == false) {
			if(pertos.size()==1)
				break;
			pertos.erase(pertos.begin()+i);
			i--;
		}
	}

	if(pertos.size()==0) {
		pertos.push_back(point(rand()%31,rand()%31));
	}

	int v=rand()+rand();
	v=v<0?-v:v;
	if( p.estrategia().tipo == ATACANDO and players[p.estrategia().inimigo].vendo) {
		ponto_mais_perto_de= players[p.estrategia().inimigo].pos;
		sort(pertos.begin(),pertos.end(),mais_perto_de3);
		return pertos[ v % min(3,(int)pertos.size())];
	}

	return pertos[v%pertos.size()];
}

//retorna true se a bola ta feita
bool faz_bola(Player& p,int tam_bola) {
	//verfica se a bola esta pronta
	if(tam_bola==1 and (p.holding=='e' or p.holding=='f' or p.holding=='g')) {
		return true;
	}
	else if(tam_bola==2 and p.holding=='h') {
		return true;
	}
	else if(tam_bola==3 and p.holding=='i') {
		return true;
	}

	//verificaçoes pra ver se preciso jogar algo fora
	//se soh tenho powdered
	if(p.holding>='b' and p.holding<='d') {
		if(tam_bola<p.holding-'b'+1) {
			drop_adjacente(p);
			return false;
		}
	}
	//se tenho algo na mao maior
	if((p.holding=='h' and tam_bola==1) or (p.holding=='j' and tam_bola<=2) or p.holding=='f' or p.holding=='g') {
		drop_adjacente(p);
		return false;
	}

	//quantidade de neve pronta
	if(p.holding-'a'==tam_bola) {
		_crush(p);
	}
	//pega + neve
	else {
		//escolhe uma neve pra pegar
		point perto=neve_mais_perto(p,p.pos);
		if(adjacente(perto,p.pos)) {
			if(p.em_pe==true)
				_crouch(p);
			else {
				if(can_pickup[perto.y][perto.x]==true) {
					_pickup(p,perto);
					can_pickup[perto.y][perto.x]=false;
				}
				else {
					_idle(p);
				}
			}
		}
		else {
			move_pra_perto(p,perto);
			//se move
		}
	}
	return false;
}

void pickup(Player& p, const point& pos) {
	if(adjacente(p.pos,pos) == true) {
		if(p.em_pe==true)
			_crouch(p);
		else {
			_pickup(p,pos);
			can_pickup[pos.y][pos.x]=false;
		}
	}
	else {
		move_pra_perto(p,pos);
	}
}

//retorna: 2 - Construindo o boneco
//retorna: 1 - conseguiu construir o boneco
//retorna: 0 - nao da pra construir o boneco naquela posicao
int constroi_boneco(Player& p) {
	//ve estado
	char est_grid=grid[p.estrategia().onde.y][p.estrategia().onde.x].occupied;
	fprintf(stderr,"%d %d\n",p.estrategia().onde.y,p.estrategia().onde.x);

	int tam_bola=-1;
	//se nao tem nada
	if(est_grid == 'a' or est_grid==-1)
		tam_bola=3;
	//se tem uma bola grande
	else if(est_grid == 'f')
		tam_bola=2;
	//se tem uma bola media em cima de uma grande
	else if(est_grid == 'g')
		tam_bola=1;
	//se ja tem meu boneco
	else if(est_grid == 'i')
		return 1;
	//se tiver boneco do adversario
	else if(est_grid == 'j') {
		//se eu tenho algo na minha mao, jogo fora
		if(p.holding!='a') {
			drop_adjacente(p);
		}
		else {
			pickup(p,p.estrategia().onde);
		}
		return 2;
	}

	//TODO verificar o q eu to segurando caso alguem tenha modificado o lugar de fazer boneco de neve

	//se ainda nao tenho a bola, entao faço ela
	//se ela estiver pronta entao eu tento dropar
	if(faz_bola(p,tam_bola) == true) {
		fprintf(stderr,"BOLA PRONTA\n");
		drop(p,p.estrategia().onde);
	}
	return 2;
}

bool eh_acertavel(const Player& p, const point& pos) {
	point dist = pos - p.pos;
	dist = dist * 2;
	if(dist.modulo() <= MAXDIST)
		return true;
	return false;
}

point closest_enemy(const Player& p) {
	point perto(10000,10000);

	for(int i=4;i<8;i++) {
		if(players[i].vendo == true) {
			if(eh_acertavel(p,players[i].pos)) {
				point dist = players[i].pos - p.pos;
				if(perto.modulo() > dist.modulo())
					perto=dist;
			}
		}
	}

	return p.pos+perto;
}

bool enemy_in_range(const Player& p) {
	return ((closest_enemy(p) - p.pos)*2).modulo() <= MAXDIST;
}

void estrategia1(Player& p) {
	bool fiz_acao=false;
	if(enemy_in_range(p)) {
		//se eu nao tenho nada ou tenho um powdered ou uma snowball
		if(p.holding == 'a' or p.holding == 'b' or p.holding == 'e') {
			//vale a pena atacar, entao tento fazer uma bola
			if(faz_bola(p,1)==true) {
				//se tenho bola pronta, entao ataca
				throw_snow(p,closest_enemy(p));
				fiz_acao=true;
			}
		}
	}
//	if(!fiz_acao)
		constroi_boneco(p);
}

bool joga_fora(Player& p) {
	if(p.em_pe==true)
		_crouch(p);
	else {
		vector<point> vp=all_with_max_dist(p.pos,1);
		_drop(p,vp[rand()%vp.size()]);
	}
	return true;
}

pair<bool,point> eh_possivel_atacar(const point& partida, const point& pos, int alt) {
	if(partida == pos)
		return make_pair(false,point());

	point direcao=pos-partida;
	for(int k=0;k<1;k++) {
		for(int l=24;l>=6;l-=2) {
			double aumentar = ((double)(l))/sqrt((direcao).modulo());
			point destino_aux(int(pos.x+(double)(direcao.x*aumentar)),int( pos.y+(double)(direcao.y*aumentar)));
			if(k==1)
				destino_aux = partida+direcao*2;
			for(int l=-1;l<=1;l++)
				for(int m=-1;m<=1;m++) {
					point destino(destino_aux.x+m,destino_aux.y+l);
					if( dist_euclidean(partida,destino) <= MAXDIST ) {
						if(onde_ataque_vai_parar(partida,destino,alt)==pos) {
							return make_pair(true,destino);
						}
					}
				}
		}

	}
	return make_pair(false,point());
}

//TODO só distancia euclidiana nao eh bom
vector<pair<point,point> > possiveis_ataques(const Player& p, const point& pos,int alt=6) {
	vector<pair<point,point> > ans;
	for(int i=0;i<T;i++)
		for(int j=0;j<T;j++) if(dist_euclidean(pos,point(j,i)) <= MAXDIST and (grid[i][j].occupied <= 'a' or point(j,i)==p.pos )) {
			point partida(j,i);
			pair<bool,point> pos_ataque=eh_possivel_atacar(partida,pos,alt);
			if(pos_ataque.first==true)
				ans.push_back(make_pair(partida,pos_ataque.second));
		}
	return ans;
}


bool ataca(Player& p) {
	if(players[p.estrategia().inimigo].vendo == false)
		return false;

	//se nao tenho nada ou uma snowball ou 2
	if((p.holding=='a' or p.holding=='e' or p.holding=='f') and !p.ajudando) {
		Player& inimigo=players[p.estrategia().inimigo];
		//se o inimigo tem alguma snowball
		if((inimigo.holding=='e' or inimigo.holding=='f' or inimigo.holding=='g') and inimigo.dazed==0) {
			if(eh_possivel_atacar(inimigo.pos,p.pos,inimigo.em_pe==true?9:6).first and rand()%1009<=1009) {
				_catch(p,inimigo.pos);
				return true;
			}
		}
	}

	//se eu nao tenho nada ou tenho um powdered ou uma,duas ou 3 snowballs
	if(p.holding == 'a' or p.holding == 'b' or p.holding == 'e' or p.holding=='f' or p.holding=='g') {
		//vale a pena atacar, entao tento fazer uma bola
		if(faz_bola(p,1)==true) {
			//se tenho bola pronta, entao ataca
			vector<pair<point,point> > pa = possiveis_ataques(p,players[p.estrategia().inimigo].pos);
			ponto_mais_perto_de=p.pos;
			sort(pa.begin(),pa.end(),mais_perto_de);
			//pega o mais perto
			if(dist_manhatan(pa[0].first,p.pos) == 0)
				throw_snow(p,pa[0].second);
			else
				move(p,pa[0].first);
		}
	}
	else {
		joga_fora(p);
	}
	return true;
}

vector<int> enemies_in_range(const Player& p,int dist=MAXDIST) {
	vector<int> ans;
	for(int i=4;i<8;i++) {
		if(players[i].vendo) {
			if( (players[i].pos - p.pos).modulo() <= dist/8)
				ans.push_back(i);
		}
	}
	ponto_mais_perto_de=p.pos;
	sort(ans.begin(),ans.end(),mais_perto_de2);
	return ans;
}

void do_someting(int p) {
	if(players[p].dazed >0) {
		_idle(players[p]);
		return;
	}
	if(players[p].ajudando==true) {
		//verifica se algum carinha meu ta precisando de ajuda
		for(int i=0;i<4;i++) {
			vector<int> er=enemies_in_range(players[i]);
			for(int j=0;j<(int)er.size();j++)
				if(usando_estrategias[er[j]]==0) {
					players[p].troca_estrategia(er[j]);
					ataca(players[p]);
					return;
				}
		}
	}
	if(players[p].estrategia_usando>=0 and players[p].estrategia_usando<n_possiveis_estrategias) {
		//se eu estiver atacando, continuo
		if(players[p].estrategia().tipo == ATACANDO) {
			//TODO verifica se ele ainda tá no range te algum carinha meu
			if(ataca(players[p]))
				return;
		}
		vector<int> enemies= enemies_in_range(players[p]);
		//verifica redondezas para ver se tem jogador perto
		if( enemies.size() > 0 ) {
			for(int i=0;i<(int)enemies.size();i++) {
				if(usando_estrategias[enemies[i]]==0) {
					players[p].troca_estrategia(enemies[i]);
					if(ataca(players[p]))
						return;
				}
			}
		}

		if(players[p].estrategia().tipo==CONSTRUIR_BONECO) {
			if(constroi_boneco(players[p]) == 2)
				return;
		}
	}

	//SEM NADA PRA FAZE
	//verifica se algum carinha meu ta precisando de ajuda
	for(int i=0;i<4;i++) {
		vector<int> er=enemies_in_range(players[i]);
		for(int j=0;j<(int)er.size();j++)
			if(usando_estrategias[er[j]]==0) {
				players[p].troca_estrategia(er[j]);
				ataca(players[p]);
				return;
			}
	}

	fprintf(stderr,"ESTRATEGIA: %d\n",players[p].estrategia_usando);
	//TODO construir mais bonecos
	for(int i=0;i<4;i++) if(usando_estrategias[i]==0) {
		players[p].troca_estrategia(i);
		if(constroi_boneco(players[p]) == 2)
			return;
	}
	vector<int> er=enemies_in_range(players[p],50*50*8);
	if(er.size()>0) {
		fprintf(stderr,"--------------------VEIOOOOOOOOOOOOOO---------------\n");
		players[p].troca_estrategia(er[0]);
		if(usando_estrategias[er[0]]>1)
			players[p].ajudando=true;
		ataca(players[p]);
		return;
	}
	faz_bola(players[p],1);
	fprintf(stderr,"--------------------NNNOOOOOOOOOOOOOOO---------------\n");
}

int Mround(double v) {
	if ( v < 0 )
		return -(int)(round( -v ));
	return (int)(round( v ));
}
#define ABS(x) (x<0?-(x):x)
point onde_ataque_vai_parar(const point& inicial, const point& final, int altura) {
	int dx=final.x-inicial.x;
	int dy=final.y-inicial.y;
	int n=max(ABS(final.x-inicial.x),ABS(final.y-inicial.y));
	for(int i=1;i<=n;i++) {
		point p(inicial.x + Mround((i*dx)/(double)(n) ), inicial.y + Mround((i*dy)/(double)n) );
		int h= altura - Mround( (9*i)/(double)n);
		//se o ponto for de onde eu joguei, entao nao bate em nada
		if(p==inicial)
			continue;
		//se esta fira do grid, entao retorna essa posicao do grid
		if(p.y<0 or p.y>=T or p.x<0 or p.x>=T)
			return p;
		//se for uma árvore, entao bate
		if(grid[p.y][p.x].occupied=='b')
			return p;
		//se a altura da bola alcancou o chao, entao bate
		if(h <= grid[p.y][p.x].height)
			return p;
		//se bateu com algum dos players
		for(int i=0;i<8;i++)
			if(players[i].vendo==true and players[i].pos == p) {
				if(players[i].em_pe==true)
					return p;
				else if(h<=6)
					return p;
			}
		//se bateu num boneco de neve
		if(grid[p.y][p.x].occupied=='i' or grid[p.y][p.x].occupied=='j')
			return p;
	}
	return final;
}

int scores[2];

int main(void) {
	int TURNO;
	initialize();
	fprintf(stderr,"inicio\n");
	while(scanf("%d",&TURNO) != EOF) {
		scanf("%d %d",scores,scores+1);
		le_entrada();
		for(int i=0;i<4;i++) {
			do_someting(i);
			fprintf(stderr,"fez um\n");
		}
		fprintf(stderr,"fez coisas\n");
		imprime_saida();
	}

	return 0;
}
